# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile

-assumenosideeffects class android.util.Log {
    public static boolean isLoggable(java.lang.String, int);
    public static int v(...);
    public static int i(...);
    public static int w(...);
    public static int d(...);
    public static int e(...);
}


-dontwarn com.franmontiel.persistentcookiejar.**


-keepclassmembers class * implements java.io.Serializable {
    static final long serialVersionUID;
    private static final java.io.ObjectStreamField[] serialPersistentFields;
    !static !transient <fields>;
    private void writeObject(java.io.ObjectOutputStream);
    private void readObject(java.io.ObjectInputStream);
    java.lang.Object writeReplace();
    java.lang.Object readResolve();
}

-dontwarn com.google.vr.ndk.base.DaydreamAp

-keepattributes *Annotation*
-keepattributes SourceFile,LineNumberTable
# prevent Crashlytics obfuscation
-dontwarn com.crashlytics.**


-dontwarn org.kobjects.**
-dontwarn org.ksoap2.**
-dontwarn org.kxml2.**
-dontwarn org.xmlpull.v1.**

-keep class com.biganto.visual.roompark.data.repository.db.requrey.model** { *; }

-keep class com.biganto.visual.roompark.player.unity_utils** { *; }
-keepclassmembers class  com.biganto.visual.roompark.player.unity_utils** { *; }


-keep class com.biganto.visual.roompark.player.BigantoPlayerActivity { *; }
-keepclassmembers class  com.biganto.visual.roompark.player.BigantoPlayerActivity** { *; }


-keep public class * implements android.os.Parcelable

# keep CREATOR for referenced parcelables since it is accessed via reflection
-keepclassmembers class * implements android.os.Parcelable {
    static ** CREATOR;
}

-dontobfuscate -optimizations !code/simplification/arithmetic,!field/*,!class/merging/*,!code/allocation/variable


# could be refined, but if it works you got the idea
-keepnames class * implements android.os.Parcelable { *; }
-keepclassmembers class * implements android.os.Parcelable { *; }

-keepnames class * implements com.bluelinelabs.conductor** { *; }
-keepclassmembers class * implements com.bluelinelabs.conductor** { *; }



-keep class * implements com.google.gson.TypeAdapterFactory
-keep class * implements com.google.gson.JsonSerializer
-keep class * implements com.google.gson.JsonDeserializer


-keep class  com.biganto.visual.roompark.data.repository.api.biganto.raw** { *; }
-keepclassmembers class  com.biganto.visual.roompark.data.repository.api.biganto.raw** { *; }


-keep class  com.biganto.visual.roompark.data.repository.api.room_park.raw** { *; }
-keepclassmembers class com.biganto.visual.roompark.data.repository.api.room_park.raw** { *; }

# prevent Requery obfuscation
-dontusemixedcaseclassnames
-dontskipnonpubliclibraryclasses
-dontoptimize
-dontpreverify

-dontwarn java.lang.FunctionalInterface
-dontwarn java.util.**
-dontwarn java.time.**
-dontwarn javax.annotation.**
-dontwarn javax.cache.**
-dontwarn javax.naming.**
-dontwarn javax.transaction.**
-dontwarn java.sql.**
-dontwarn javax.sql.**
-dontwarn androidx.**
-dontwarn io.requery.cache.**
-dontwarn io.requery.rx.**
-dontwarn io.requery.reactivex.**
-dontwarn io.requery.reactor.**
-dontwarn io.requery.query.**
-dontwarn io.requery.android.sqlcipher.**
-dontwarn io.requery.android.sqlitex.**

-keepclassmembers enum io.requery** {
    public static **[] values();
    public static ** valueOf(java.lang.String);
}


# google vr sdk
# Don't obfuscate any NDK/SDK code. This makes the debugging of stack traces
# in release builds easier.
-keepnames class com.google.vr.ndk** { *; }
-keepnames class com.google.vr.sdk** { *; }

# These are part of the Java <-> native interfaces for GVR.
-keepclasseswithmembernames,includedescriptorclasses class com.google.vr** {
    native <methods>;
}

# The SDK configuration protos use reflection.
-keep class com.google.vr.sdk.proto** {
    *;
}
-keep class com.google.common.logging.Vr$VREvent$SdkConfigurationParams** {
    *;
}
-keep class com.google.common.logging.nano.Vr$VREvent$SdkConfigurationParams** {
    *;
}

-keep class com.google.vr.cardboard.UsedByNative
-keep @com.google.vr.cardboard.UsedByNative class *
-keepclassmembers class * {
    @com.google.vr.cardboard.UsedByNative *;
}

-keep class com.google.vr.cardboard.annotations.UsedByNative
-keep @com.google.vr.cardboard.annotations.UsedByNative class *
-keepclassmembers class * {
    @com.google.vr.cardboard.annotations.UsedByNative *;
}

-keep class com.google.vr.cardboard.annotations.UsedByReflection
-keep @com.google.vr.cardboard.annotations.UsedByReflection class *
-keepclassmembers class * {
    @com.google.vr.cardboard.annotations.UsedByReflection *;
}

-dontwarn sun.misc.Unsafe
-dontwarn libcore.io.Memory
# end googlevr sdk


-dontusemixedcaseclassnames
-dontwarn android.support.**
-verbose

-dontoptimize
-dontpreverify

-keep  class com.unity3d** { *; }
-keep  class org.fmod** { *; }

-keep  class bitter.jnibridge** { *; }


-keepclassmembers   class com.tms.rarus.videoserver.* { *; }
-keepclassmembers   class com.unity3d.player** { *; }
-keepclassmembers   class org.fmod** { *; }

-keepclasseswithmembernames class * {
    native <methods>;
}

-keep class com.google.firebase.crashlytics** { *; }
-dontwarn com.google.firebase.crashlytics.**


-keep class com.google.android.gms** { *; }
-dontwarn com.google.android.gms.**

-keep class com.biganto.androidplayer** { *; }
-keepclassmembers   class com.biganto.androidplayer.* { *; }

-libraryjars ./libs/unity-classes.jar
#-libraryjars ./libs/libprotobuf-java-nano.jar

-keep interface kotlin.reflect.jvm.internal.impl.builtins.BuiltInsLoader
-keep class kotlin.reflect.jvm.internal.impl.serialization.deserialization.builtins.BuiltInsLoaderImpl

-keep class com.biganto.visual.roompark.presentation.screen.settings.util** { *; }
-keepclassmembers   class com.biganto.visual.roompark.presentation.screen.settings.util** { *; }

-dontwarn kotlin.reflect.jvm.internal.**

-keep class kotlin** {
    public protected *;
}
-keepclassmembers class * { public <init>(...); }